import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class Game {
    Scanner scanner = new Scanner(System.in);
    CardList cardList = new CardList();
    ArrayList<Player> players = new ArrayList<>();
    int cartToDraw = 2;
    Random random = new Random();
    Show show = new Show();
    int turn;
    int rotation;
    String color;

    public Game() {

        color = "";
        System.out.print("How many human players? ");
        int number = scanner.nextInt();
        for (int i = 0; i < number; i++) {
            System.out.print("Player name: ");
            String name = scanner.next();
            Player player = new Player(name, false);
            players.add(player);
            /**
             *add 7 cards to each player
             */
            for (int j = 0; j < 7; j++) {
                int color = random.nextInt(cardList.getCards().size());
                Card card = cardList.drawCard();
                player.addCard(card);
            }
        }

        System.out.print("How many Bot players? ");
        int numbers = scanner.nextInt();
        for (int i = 0; i < numbers; i++) {
            System.out.print("Player name: ");
            String name = scanner.next();
            Player player = new Player(name, true);
            players.add(player);
            /**
             *add 7 cards to each player
             */
            for (int j = 0; j < 7; j++) {
                int color = random.nextInt(cardList.getCards().size());
                Card card = cardList.drawCard();
                player.addCard(card);
            }
        }

        while (true) {
            int color = new Random().nextInt(cardList.getCards().size());
            Card startCart = cardList.getCards().get(color);
            if (!(startCart.getCardType().name().contains("SKIP") && startCart.getCardType().name().contains("REVERSE") && startCart.getCardType().name().contains("WILD") && startCart.getCardType().name().contains("WILD_DRAW") && startCart.getCardType().name().contains("DRAW2")))
                break;
        }

        // initialize
        turn = new Random().nextInt(players.size());
        rotation = (new Random().nextInt(2) == 0) ? 1 : -1;
    }

    public void rotate(int turn, int rotation) {
        turn += rotation;
        if (turn < 0)
            turn = players.size() - 1;
        else if (turn >= players.size())
            turn = 0;
    }


    public void play(Card table) {

        while (!isGameOver(players)) {

            show.show(players, table, turn, rotation);

            color = "";
            cardList.addCard(table);

            switch (table.getCardValue()) {
                case "SKIP":
                    goTurn();
                    System.out.println("Player '" + players.get(reverseTurn()).getName() + "' is skipped");
                    show.show(players, table, turn, rotation );
                    break;
                case "REVERSE":
                    rotation *= -1;
                    if (players.size() == 2)
                        goTurn();
                    else {
                        goTurn();
                        goTurn();
                    }
                    show.show(players, table, turn, rotation );
                    System.out.println("rotation is reversed");
                    break;
                case "DRAW2":
                    System.out.print("Player '" + players.get(turn).getName() + "' is given two cards and is skipped: ");
                    for (int i = 0; i < 2; i++) {
                        Card temp = cardList.drawCard();
                        players.get(turn).addCard(temp);
                        System.out.print(temp.getCardColor() + " " + temp.getCardValue() + " " + ConsoleColors.RESET + " ");
                    }
                    System.out.println();
                    goTurn();
                    show.show(players, table, turn, rotation );
                    break;
            }

            if (table.getCardType() == CardType.WILD || table.getCardType() == CardType.WILD_DRAW4) {
                if(players.get(turn).getIsAI()) {
                    switch (random.nextInt(4)) {
                        case 0:
                            System.out.println("Changed color to: Yellow");
                            color = ConsoleColors.YELLOW_BACKGROUND_BRIGHT;
                            break;
                        case 1:
                            System.out.println("Changed color to: Red");
                            color = ConsoleColors.RED_BACKGROUND_BRIGHT;
                            break;
                        case 2:
                            System.out.println("Changed color to: Green");
                            color = ConsoleColors.GREEN_BACKGROUND_BRIGHT;
                            break;
                        case 3:
                            System.out.println("Changed color to: Blue");
                            color = ConsoleColors.BLUE_BACKGROUND_BRIGHT;
                            break;
                    }
                }else{
                    System.out.println("choose color");
                    do {
                        color = scanner.next();
                    }while (!color.equals("BLUE") && !color.equals("RED") && !color.equals("GREEN") && !color.equals("YELLOW"));

                    if(color.equals("BLUE"))
                        color = ConsoleColors.BLUE_BACKGROUND_BRIGHT;
                    if(color.equals("RED"))
                        color = ConsoleColors.RED_BACKGROUND_BRIGHT;
                    if(color.equals("GREEN"))
                        color = ConsoleColors.GREEN_BACKGROUND_BRIGHT;
                    if(color.equals("YELLOW"))
                        color = ConsoleColors.YELLOW_BACKGROUND_BRIGHT;
                }



                if (table.getCardType() == CardType.WILD_DRAW4) {
                    System.out.print("Player '" + players.get(turn).getName() + "' is given four cards and is skipped: ");
                    for (int i = 0; i < 4; i++) {
                        Card temp = cardList.drawCard();
                        players.get(turn).addCard(temp);
                        System.out.print(temp.getCardColor() + " " + temp.getCardValue() + " " + ConsoleColors.RESET + " ");
                    }
                    System.out.println();
                    goTurn();
                }
            }

            if (canDraw(players.get(turn), table, color)) {    // Player has a card to draw

                if (players.get(turn).getIsAI())    // It is a bot!
                    table = players.get(turn).play(table, color);
                else {  // It is a HUMAN!!!
                    String user_card = null;
                    while (!players.get(turn).contains(user_card) || !players.get(turn).canDraw(table, players.get(turn).getEquavalentCard(user_card), color)) {
                        System.out.print("Hey user! enter a card: ");
                        user_card = scanner.nextLine();
                        System.out.println(players.get(turn).contains(user_card));
                        //System.out.println(players.get(turn).canDraw(table, players.get(turn).getEquavalentCard(user_card)));
                    }

                    table = players.get(turn).getEquavalentCard(user_card);
                    players.get(turn).removeCard(players.get(turn).getEquavalentCard(user_card));
                }


            } else {    // We are out of options
                players.get(turn).addCard(cardList.drawCard());
                Card givenCard = players.get(turn).getCards().get(players.get(turn).getCards().size() - 1);
                System.out.println("Player '" + players.get(turn).getName() + "' is given a card: " + givenCard.getCardColor() + " " + givenCard.getCardValue() + " " + ConsoleColors.RESET);

                // Can the player draw the given card??!
                if (canDraw(players.get(turn), table, color)) {

                    if (players.get(turn).getIsAI())    // It is a bot!
                        table = players.get(turn).play(table, color);
                    else {  // It is a HUMAN!!!
                        String user_card = null;
                        while (!players.get(turn).contains(user_card) || !players.get(turn).canDraw(table, players.get(turn).getEquavalentCard(user_card), color)) {
                            System.out.print("Hey user! enter a card: ");
                            user_card = scanner.nextLine();
                        }

                        table = players.get(turn).getEquavalentCard(user_card);
                        players.get(turn).removeCard(players.get(turn).getEquavalentCard(user_card));
                    }
                } else
                    System.out.println("Player '" + players.get(turn).getName() + "' is skipped, no moves");
            }

//            show.show(players, table, turn, rotation);

            goTurn();   // Increase turn

            for(Player player: players) {
                if (player.getCards().size() == 0)
                    player.setScore(0);
                else{
                    for(Card card: player.getCards()){
                        player.setScore(player.getScore() + card.getCardScore());
                    }
                }
            }
        }

        for (Player player: players) {
            System.out.print("Player '" + player.getName() + "' score: " + player.getScore());
            if (player.getCards().size() == 0)
                System.out.print("\tWINNER!");
            System.out.println();
        }
    }

    /**
     * changes the turn by rotation
     */
    private void goTurn() {
        turn += rotation;
        if (turn >= players.size())
            turn = 0;
        if (turn < 0)
            turn = players.size() - 1;
    }

    /**
     * changes the rotation
     * @return the new turns
     */
    private int reverseTurn() {
        int backTurn = turn - rotation;
        if (backTurn >= players.size())
            backTurn = 0;
        if (backTurn < 0)
            backTurn = players.size() - 1;

        return backTurn;
    }

    /**
     * checking if the player has a card to draw
     * @param player
     * @param table
     * @param color
     * @return true or false
     */
    private boolean canDraw(Player player, Card table, String color) {
        ArrayList<Card> playerCards = player.getCards();
        ArrayList<String> breakDown = new ArrayList<>();    // Contains values and colors
        for (Card card : playerCards) {
            if (card.getCardType() != CardType.WILD && card.getCardType() != CardType.WILD_DRAW4) { // Not WILD & WILD_DRAW4
                breakDown.add(card.getCardValue());     // Add card's value
                breakDown.add(card.getCardColor());     // Add cards's color
            }
        }

        // If card on the table is either WILD or DRAW4
        if (!color.equals("") && breakDown.contains(color))
            return true;
        else if (!color.equals("") && !breakDown.contains(color))
            return false;

        if (breakDown.contains(table.getCardValue()) || (breakDown.contains(table.getCardColor())))
            return true;    // We have an ordinary card with the same value or color

        // What about WILD?
        for (Card card : playerCards)
            if (card.getCardType() == CardType.WILD)
                return true;

        // WILD_DRAW4????
        for (Card card : playerCards)
            if (card.getCardType() == CardType.WILD_DRAW4)
                return true;

        return false;   // We have nothing to draw ):
    }

    /**
     * checking if anyone has won
     * @param players
     * @return
     */
    public static boolean isGameOver(ArrayList<Player> players) {
        for (Player player : players)
            if (player.getCards().size() == 0)
                return true;
        return false;
    }
}
